// Jan Koci Software
// honza.koci@email.cz
// http://koci.opengl.cz

unit coll_f;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus,OpenGL;

const Velikost = 256;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }

    RC : HGLRC;
    buffer : array[1..Velikost,1..Velikost] of record
                                             blue : byte;
                                             green : byte;
                                             red : byte
                                           end;
    procedure InitElements;                                       
    procedure DrawElements;
    procedure InicializaceOpenGL;
    procedure ZobrazitScenu;
    procedure PixelovyFormat(DC : HDC);
    procedure NastaveniProstoru;
    procedure VlastnostiObjektu;
    procedure LoadBitmap(Path : string);
    procedure VymazatPlochu(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure ProcessKeyb;
    procedure SetFullScreen(SizeX,SizeY,Bits:longint);
    procedure RestoreMode;
    procedure ClipPlane;
    procedure InitCollision;
    procedure Collision;

  public
    { Public declarations }
    X,Y,Z: real;                                      //pozice kamery
    UhelX,UhelY,UhelZ: integer;                       //uhel rotace kamery
    Textura: array [0..5] of integer;
    Xtrue, Ytrue, Ztrue: array [1..6] of boolean;     //kolizni hodnoty
    PxLast, PyLast, PzLast: array [1..6] of double;   //posledni pozice kamery pred kolizi
  end;

//body
type TVertexPointer = array [0..5] of record
  X: TGLFloat;
  Y: TGLFloat;
  Z: TGLFloat;
end;
type TVertexPointer2 = array [0..5] of record
  X: TGLFloat;
  Y: TGLFloat;
  Z: TGLFloat;
end;
type TVertexPointer3 = array [0..5] of record
  X: TGLFloat;
  Y: TGLFloat;
  Z: TGLFloat;
end;
type TVertexPointer4 = array [0..5] of record
  X: TGLFloat;
  Y: TGLFloat;
  Z: TGLFloat;
end;
type TVertexPointer5 = array [0..5] of record
  X: TGLFloat;
  Y: TGLFloat;
  Z: TGLFloat;
end;
type TVertexPointer6 = array [0..5] of record
  X: TGLFloat;
  Y: TGLFloat;
  Z: TGLFloat;
end;


//texturova koordinace
type TCoordPointer = array [0..5] of record
  S: TGLFloat;
  K: TGLFloat;
end;
type TCoordPointer2 = array [0..5] of record
  S: TGLFloat;
  K: TGLFloat;
end;
type TCoordPointer3 = array [0..5] of record
  S: TGLFloat;
  K: TGLFloat;
end;
type TCoordPointer4 = array [0..5] of record
  S: TGLFloat;
  K: TGLFloat;
end;
type TCoordPointer5 = array [0..5] of record
  S: TGLFloat;
  K: TGLFloat;
end;
type TCoordPointer6 = array [0..5] of record
  S: TGLFloat;
  K: TGLFloat;
end;

//indikator poli
type TIndices = array [0..5] of TGluInt;
type TIndices2 = array [0..5] of TGluInt;
type TIndices3 = array [0..5] of TGluInt;
type TIndices4 = array [0..5] of TGluInt;
type TIndices5 = array [0..5] of TGluInt;
type TIndices6 = array [0..5] of TGluInt;

//orezavani sceny, ktera stejne neni videt
type
  TPlane = record
    x: double;
    y: double;
    z: double;
    a: double;
end;


var
  Form1: TForm1;
  Handles : integer;
  ThreadID : LongWord;

implementation

{$R *.DFM}



const PFDError = 'Chyba pi nastaven PFD.';

var
  VertexPointer: TVertexPointer;
  VertexPointer2: TVertexPointer2;
  VertexPointer3: TVertexPointer3;
  VertexPointer4: TVertexPointer4;
  VertexPointer5: TVertexPointer5;
  VertexPointer6: TVertexPointer6;
  CoordPointer: TCoordPointer;
  CoordPointer2: TCoordPointer2;
  CoordPointer3: TCoordPointer3;
  CoordPointer4: TCoordPointer4;
  CoordPointer5: TCoordPointer5;
  CoordPointer6: TCoordPointer6;
  Indices: TIndices;
  Indices2: TIndices2;
  Indices3: TIndices3;
  Indices4: TIndices4;
  Indices5: TIndices5;
  Indices6: TIndices6;

  Plane: TPlane;

  KeybUp, KeybDown, KeybRight, KeybLeft, KeybHome, KeybEnd, KeybEsc, KeybMoveUp, KeybMoveDown: boolean;
  Cesta: string;




function Tread(P : pointer) : integer;
var
  i: integer;
begin
  i := 1;
  repeat
    Form1.Repaint;
  until
    i = 2;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  FillChar(Handles, sizeof(Handles), 0);
end;

procedure TForm1.InitElements;
begin
   Cesta := ExtractFilePath(Application.ExeName);                     //cesta k texturam

   //nacteni textur
   LoadBitmap(Cesta + 'Image1.bmp');
   glGenTextures(1, @textura[0]);
   glBindTexture(GL_TEXTURE_2D, textura[0]);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_S,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_T,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Mag_Filter,GL_Linear);
   glTexParameterf(GL_Texture_2D,GL_Texture_Min_Filter,GL_Linear);
   glTexImage2d(GL_Texture_2D,0,3,Velikost,Velikost,0,GL_RGB,GL_Unsigned_byte,@buffer);

   LoadBitmap(Cesta + 'Image2.bmp');
   glGenTextures(1, @textura[1]);
   glBindTexture(GL_TEXTURE_2D, textura[1]);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_S,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_T,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Mag_Filter,GL_Linear);
   glTexParameterf(GL_Texture_2D,GL_Texture_Min_Filter,GL_Linear);
   glTexImage2d(GL_Texture_2D,0,3,Velikost,Velikost,0,GL_RGB,GL_Unsigned_byte,@buffer);

   LoadBitmap(Cesta + 'Image3.bmp');
   glGenTextures(1, @textura[2]);
   glBindTexture(GL_TEXTURE_2D, textura[2]);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_S,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_T,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Mag_Filter,GL_Linear);
   glTexParameterf(GL_Texture_2D,GL_Texture_Min_Filter,GL_Linear);
   glTexImage2d(GL_Texture_2D,0,3,Velikost,Velikost,0,GL_RGB,GL_Unsigned_byte,@buffer);

   LoadBitmap(Cesta + 'Image4.bmp');
   glGenTextures(1, @textura[3]);
   glBindTexture(GL_TEXTURE_2D, textura[3]);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_S,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_T,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Mag_Filter,GL_Linear);
   glTexParameterf(GL_Texture_2D,GL_Texture_Min_Filter,GL_Linear);
   glTexImage2d(GL_Texture_2D,0,3,Velikost,Velikost,0,GL_RGB,GL_Unsigned_byte,@buffer);

   LoadBitmap(Cesta + 'Image5.bmp');
   glGenTextures(1, @textura[4]);
   glBindTexture(GL_TEXTURE_2D, textura[4]);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_S,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_T,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Mag_Filter,GL_Linear);
   glTexParameterf(GL_Texture_2D,GL_Texture_Min_Filter,GL_Linear);
   glTexImage2d(GL_Texture_2D,0,3,Velikost,Velikost,0,GL_RGB,GL_Unsigned_byte,@buffer);

   LoadBitmap(Cesta + 'Image6.bmp');
   glGenTextures(1, @textura[5]);
   glBindTexture(GL_TEXTURE_2D, textura[5]);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_S,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_T,GL_Repeat);
   glTexParameterf(GL_Texture_2D,GL_Texture_Mag_Filter,GL_Linear);
   glTexParameterf(GL_Texture_2D,GL_Texture_Min_Filter,GL_Linear);
   glTexImage2d(GL_Texture_2D,0,3,Velikost,Velikost,0,GL_RGB,GL_Unsigned_byte,@buffer);



   glEnableClientState(GL_VERTEX_ARRAY);                              //aktivuje pole bodu
   glEnableClientState(GL_TEXTURE_COORD_ARRAY);                       //aktivuje pole texturovych koordinaci


/////////////////////////////////////////////////////////////////////////////
//prvni stena

    //pozice bodu 1
    VertexPointer[0].X := -10;
    VertexPointer[0].Y := 2;
    VertexPointer[0].Z := 0;
    //texturova koordinace bodu 1
    CoordPointer[0].S := 4;
    CoordPointer[0].K := 1;
    //identifikace bodu 1
    Indices[0] := 0;

    //pozice bodu 2
    VertexPointer[1].X := 10;
    VertexPointer[1].Y := 2;
    VertexPointer[1].Z := 0;
    //texturova koordinace bodu 2
    CoordPointer[1].S := 0;
    CoordPointer[1].K := 1;
    //identifikace bodu 2
    Indices[1] := 1;

    //pozice bodu 3
    VertexPointer[2].X := -10;
    VertexPointer[2].Y := -1;
    VertexPointer[2].Z := 0;
    //texturova koordinace bodu 3
    CoordPointer[2].S := 4;
    CoordPointer[2].K := 0;
    //identifikace bodu 3
    Indices[2] := 2;


    //druhy trojuhelnik
    VertexPointer[3].X := -10;
    VertexPointer[3].Y := -1;
    VertexPointer[3].Z := 0;
    CoordPointer[3].S := 4;
    CoordPointer[3].K := 0;
    Indices[3] := 3;


    VertexPointer[4].X := 10;
    VertexPointer[4].Y := 2;
    VertexPointer[4].Z := 0;
    CoordPointer[4].S := 0;
    CoordPointer[4].K := 1;
    Indices[4] := 4;


    VertexPointer[5].X := 10;
    VertexPointer[5].Y := -1;
    VertexPointer[5].Z := 0;
    CoordPointer[5].S := 0;
    CoordPointer[5].K := 0;
    Indices[5] := 5;


/////////////////////////////////////////////////////////////////////////////
//druha stena

    //pozice bodu 1
    VertexPointer2[0].X :=  10;
    VertexPointer2[0].Y := 2;
    VertexPointer2[0].Z := -20;
    //texturova koordinace bodu 1
    CoordPointer2[0].S := 4;
    CoordPointer2[0].K := 1;
    //identifikace bodu 1
    Indices2[0] := 0;

    //pozice bodu 2
    VertexPointer2[1].X := 10;
    VertexPointer2[1].Y := 2;
    VertexPointer2[1].Z := 0;
    //texturova koordinace bodu 2
    CoordPointer2[1].S := 0;
    CoordPointer2[1].K := 1;
    //identifikace bodu 2
    Indices2[1] := 1;

    //pozice bodu 3
    VertexPointer2[2].X := 10;
    VertexPointer2[2].Y := -1;
    VertexPointer2[2].Z := -20;
    //texturova koordinace bodu 3
    CoordPointer2[2].S := 4;
    CoordPointer2[2].K := 0;
    //identifikace bodu 3
    Indices2[2] := 2;


    //druhy trojuhelnik
    VertexPointer2[3].X := 10;
    VertexPointer2[3].Y := -1;
    VertexPointer2[3].Z := -20;
    CoordPointer2[3].S := 4;
    CoordPointer2[3].K := 0;
    Indices2[3] := 3;


    VertexPointer2[4].X := 10;
    VertexPointer2[4].Y := 2;
    VertexPointer2[4].Z := 0;
    CoordPointer2[4].S := 0;
    CoordPointer2[4].K := 1;
    Indices2[4] := 4;


    VertexPointer2[5].X := 10;
    VertexPointer2[5].Y := -1;
    VertexPointer2[5].Z := 0;
    CoordPointer2[5].S := 0;
    CoordPointer2[5].K := 0;
    Indices2[5] := 5;


/////////////////////////////////////////////////////////////////////////////
//treti stena

    //pozice bodu 1
    VertexPointer3[0].X := 10;
    VertexPointer3[0].Y := 2;
    VertexPointer3[0].Z := -20;
    //texturova koordinace bodu 1
    CoordPointer3[0].S := 4;
    CoordPointer3[0].K := 1;
    //identifikace bodu 1
    Indices3[0] := 0;

    //pozice bodu 2
    VertexPointer3[1].X := -10;
    VertexPointer3[1].Y := 2;
    VertexPointer3[1].Z := -20;
    //texturova koordinace bodu 2
    CoordPointer3[1].S := 0;
    CoordPointer3[1].K := 1;
    //identifikace bodu 2
    Indices3[1] := 1;

    //pozice bodu 3
    VertexPointer3[2].X := 10;
    VertexPointer3[2].Y := -1;
    VertexPointer3[2].Z := -20;
    //texturova koordinace bodu 3
    CoordPointer3[2].S := 4;
    CoordPointer3[2].K := 0;
    //identifikace bodu 3
    Indices3[2] := 2;


    //druhy trojuhelnik
    VertexPointer3[3].X := 10;
    VertexPointer3[3].Y := -1;
    VertexPointer3[3].Z := -20;
    CoordPointer3[3].S := 4;
    CoordPointer3[3].K := 0;
    Indices3[3] := 3;


    VertexPointer3[4].X := -10;
    VertexPointer3[4].Y := 2;
    VertexPointer3[4].Z := -20;
    CoordPointer3[4].S := 0;
    CoordPointer3[4].K := 1;
    Indices3[4] := 4;


    VertexPointer3[5].X := -10;
    VertexPointer3[5].Y := -1;
    VertexPointer3[5].Z := -20;
    CoordPointer3[5].S := 0;
    CoordPointer3[5].K := 0;
    Indices3[5] := 5;


/////////////////////////////////////////////////////////////////////////////
//ctvrta stena

    //pozice bodu 1
    VertexPointer4[0].X :=  -10;
    VertexPointer4[0].Y := 2;
    VertexPointer4[0].Z := 0;
    //texturova koordinace bodu 1
    CoordPointer4[0].S := 4;
    CoordPointer4[0].K := 1;
    //identifikace bodu 1
    Indices4[0] := 0;

    //pozice bodu 2
    VertexPointer4[1].X := -10;
    VertexPointer4[1].Y := 2;
    VertexPointer4[1].Z := -20;
    //texturova koordinace bodu 2
    CoordPointer4[1].S := 0;
    CoordPointer4[1].K := 1;
    //identifikace bodu 2
    Indices4[1] := 1;

    //pozice bodu 3
    VertexPointer4[2].X := -10;
    VertexPointer4[2].Y := -1;
    VertexPointer4[2].Z := 0;
    //texturova koordinace bodu 3
    CoordPointer4[2].S := 4;
    CoordPointer4[2].K := 0;
    //identifikace bodu 3
    Indices4[2] := 2;


    //druhy trojuhelnik
    VertexPointer4[3].X := -10;
    VertexPointer4[3].Y := -1;
    VertexPointer4[3].Z := 0;
    CoordPointer4[3].S := 4;
    CoordPointer4[3].K := 0;
    Indices4[3] := 3;


    VertexPointer4[4].X := -10;
    VertexPointer4[4].Y := 2;
    VertexPointer4[4].Z := -20;
    CoordPointer4[4].S := 0;
    CoordPointer4[4].K := 1;
    Indices4[4] := 4;


    VertexPointer4[5].X := -10;
    VertexPointer4[5].Y := -1;
    VertexPointer4[5].Z := -20;
    CoordPointer4[5].S := 0;
    CoordPointer4[5].K := 0;
    Indices4[5] := 5;


/////////////////////////////////////////////////////////////////////////////
//strop

    //pozice bodu 1
    VertexPointer5[0].X :=  -10;
    VertexPointer5[0].Y := 2;
    VertexPointer5[0].Z := -20;
    //texturova koordinace bodu 1
    CoordPointer5[0].S := 10;
    CoordPointer5[0].K := 10;
    //identifikace bodu 1
    Indices5[0] := 0;

    //pozice bodu 2
    VertexPointer5[1].X := 10;
    VertexPointer5[1].Y := 2;
    VertexPointer5[1].Z := -20;
    //texturova koordinace bodu 3
    CoordPointer5[1].S := 10;
    CoordPointer5[1].K := 0;
    //identifikace bodu 3
    Indices5[1] := 1;

    //pozice bodu 3
    VertexPointer5[2].X := -10;
    VertexPointer5[2].Y := 2;
    VertexPointer5[2].Z := 0;
    //texturova koordinace bodu 2
    CoordPointer5[2].S := 0;
    CoordPointer5[2].K := 10;
    //identifikace bodu 2
    Indices5[2] := 2;

    //druhy trojuhelnik
    VertexPointer5[3].X := -10;
    VertexPointer5[3].Y := 2;
    VertexPointer5[3].Z := 0;
    CoordPointer5[3].S := 0;
    CoordPointer5[3].K := 10;
    Indices5[3] := 3;

    VertexPointer5[4].X := 10;
    VertexPointer5[4].Y := 2;
    VertexPointer5[4].Z := -20;
    CoordPointer5[4].S := 10;
    CoordPointer5[4].K := 0;
    Indices5[4] := 4;

    VertexPointer5[5].X := 10;
    VertexPointer5[5].Y := 2;
    VertexPointer5[5].Z := 0;
    CoordPointer5[5].S := 0;
    CoordPointer5[5].K := 0;
    Indices5[5] := 5;


/////////////////////////////////////////////////////////////////////////////
//podhlaha

    //pozice bodu 1
    VertexPointer6[0].X :=  -10;
    VertexPointer6[0].Y := -1;
    VertexPointer6[0].Z := -20;
    //texturova koordinace bodu 1
    CoordPointer6[0].S := 10;
    CoordPointer6[0].K := 10;
    //identifikace bodu 1
    Indices6[0] := 0;

    //pozice bodu 2
    VertexPointer6[1].X := 10;
    VertexPointer6[1].Y := -1;
    VertexPointer6[1].Z := -20;
    //texturova koordinace bodu 3
    CoordPointer6[1].S := 10;
    CoordPointer6[1].K := 0;
    //identifikace bodu 3
    Indices6[1] := 1;

    //pozice bodu 3
    VertexPointer6[2].X := -10;
    VertexPointer6[2].Y := -1;
    VertexPointer6[2].Z := 0;
    //texturova koordinace bodu 2
    CoordPointer6[2].S := 0;
    CoordPointer6[2].K := 10;
    //identifikace bodu 2
    Indices6[2] := 2;

    //druhy trojuhelnik
    VertexPointer6[3].X := -10;
    VertexPointer6[3].Y := -1;
    VertexPointer6[3].Z := 0;
    CoordPointer6[3].S := 0;
    CoordPointer6[3].K := 10;
    Indices6[3] := 3;

    VertexPointer6[4].X := 10;
    VertexPointer6[4].Y := -1;
    VertexPointer6[4].Z := -20;
    CoordPointer6[4].S := 10;
    CoordPointer6[4].K := 0;
    Indices6[4] := 4;

    VertexPointer6[5].X := 10;
    VertexPointer6[5].Y := -1;
    VertexPointer6[5].Z := 0;
    CoordPointer6[5].S := 0;
    CoordPointer6[5].K := 0;
    Indices6[5] := 5;



end;

procedure TForm1.DrawElements;
begin

  glPushMatrix;
  glTranslatef(X,Y,Z);

  //prvni stena
  glBindTexture(GL_TEXTURE_2D, textura[0]);                          //nacte texturu
  glTexCoordPointer(2, GL_FLOAT, 0, @CoordPointer);                  //nacte pole texturovych koordinaci
  glVertexPointer(3, GL_FLOAT, 0, @VertexPointer);                   //nacte pole bodu
  glDrawElements(GL_TRIANGLE_STRIP, 6, GL_UNSIGNED_INT, @Indices);        //zobrazi vysledny objekt


  //druha stena
  glBindTexture(GL_TEXTURE_2D, textura[1]);
  glTexCoordPointer(2, GL_FLOAT, 0, @CoordPointer2);
  glVertexPointer(3, GL_FLOAT, 0, @VertexPointer2);
  glDrawElements(GL_TRIANGLES, 6, GL_UNSIGNED_INT, @Indices2);

  //treti stena
  glBindTexture(GL_TEXTURE_2D, textura[2]);
  glTexCoordPointer(2, GL_FLOAT, 0, @CoordPointer3);
  glVertexPointer(3, GL_FLOAT, 0, @VertexPointer3);
  glDrawElements(GL_TRIANGLES, 6, GL_UNSIGNED_INT, @Indices3);

  //ctvrta stena
  glBindTexture(GL_TEXTURE_2D, textura[3]);
  glTexCoordPointer(2, GL_FLOAT, 0, @CoordPointer4);
  glVertexPointer(3, GL_FLOAT, 0, @VertexPointer4);
  glDrawElements(GL_TRIANGLES, 6, GL_UNSIGNED_INT, @Indices4);

  //strop
  glBindTexture(GL_TEXTURE_2D, textura[4]);
  glTexCoordPointer(2, GL_FLOAT, 0, @CoordPointer5);
  glVertexPointer(3, GL_FLOAT, 0, @VertexPointer5);
  glDrawElements(GL_TRIANGLES, 6, GL_UNSIGNED_INT, @Indices5);

  //podhlaha
  glBindTexture(GL_TEXTURE_2D, textura[5]);
  glTexCoordPointer(2, GL_FLOAT, 0, @CoordPointer6);
  glVertexPointer(3, GL_FLOAT, 0, @VertexPointer6);                   
  glDrawElements(GL_TRIANGLES, 6, GL_UNSIGNED_INT, @Indices6);



  glPopMatrix;

end;

procedure TForm1.ClipPlane;
begin
  glPushMatrix;
  //rotace orezavani
  glRotatef(-UhelY+180,0,1,0);
  //pozice orezavani
  Plane.x := 0;
  Plane.y := 0;
  Plane.z := Z;
  Plane.a := 1;
  //zapnuti orezavani
  glEnable(GL_CLIP_PLANE0);
  glClipPlane(GL_CLIP_PLANE0, @Plane);

  glPopMatrix;
end;

procedure TForm1.InicializaceOpenGL;
begin
  PixelovyFormat(Canvas.Handle);
  RC := wglCreateContext(Canvas.Handle);
  wglMakeCurrent(Canvas.Handle,RC);
  glClearColor(0.0,0.0,0.0,0.0);
  glShadeModel(GL_SMOOTH);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_Texture_2D);
  glPixelStorei(GL_Unpack_Alignment,2);
  glTexEnvf(GL_Texture_Env, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  InitElements;
  NastaveniProstoru;
  wglMakeCurrent(0,0);
end;

procedure TForm1.PixelovyFormat(DC : HDC);
var PFD : TPixelFormatDescriptor;
    nPixelFormat : integer;
begin
  FillChar(PFD,SizeOf(PFD),0);
  with PFD do
    begin
       nSize := SizeOf(TPixelFormatDescriptor);
       nVersion := 1;
       dwFlags := PFD_DRAW_TO_WINDOW or
                  PFD_SUPPORT_OPENGL or
                  PFD_DOUBLEBUFFER;
       iPixelType := PFD_TYPE_RGBA;
       cColorBits := 24;
       cDepthBits   := 32;
       iLayerType   := PFD_MAIN_PLANE;
    end;
  nPixelFormat := ChoosePixelFormat(DC,@PFD);
  Assert(nPixelFormat <> 0,PFDError);
  SetPixelFormat(DC,nPixelFormat,@PFD)
end;

procedure TForm1.NastaveniProstoru;
begin
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(30.0,ClientWidth / ClientHeight,0.001,100.0);
  glViewport(0,0,ClientWidth,ClientHeight);
end;
            
procedure TForm1.VlastnostiObjektu;
begin
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
  glTranslatef(0,0,0);				//pozice kamery
  glRotatef(UhelX, 1, 0, 0);			//rotace  X
  glRotatef(UhelY, 0, 1, 0);			//rotace  Y
  glRotatef(UhelZ, 0, 0, 1);			//rotace  Z }
end;


procedure TForm1.LoadBitmap(Path : string);
//  nate bitmapu o velikosti 256 x 256 pixelu ze souboru
//  prohodi ervenou a modrou sloku
//  bitmapu jin velikosti je nutno upravit tak, aby
//  jeji ka a vka byla mocninou dvou
var
 X : TImage;
 bih : TBitmapInfoHeader;
 bi : TBitmapInfo;
 b : byte;
 i,j : word;
begin
  X := TImage.Create(Self);
  X.Picture.LoadFromFile(Path);
  with bih do
    begin
      biSize := SizeOf(bih);
      biWidth := Velikost;
      biHeight := Velikost;
      biPlanes := 1;
      biBitCount := 24;
      biCompression := BI_RGB;
      biSizeImage := Velikost;
      biXPelsPerMeter := 0;
      biYPelsPerMeter := 0;
      biClrImportant := 0;
      biClrUsed := 0;
    end;
  bi.bmiHeader := bih;
  GetDIBits(X.Picture.Bitmap.Canvas.Handle,X.Picture.Bitmap.Handle,
            0,Velikost,@buffer,bi,dib_rgb_colors);
  for i := 1 to Velikost do
    for j := 1 to Velikost do
      begin
        b := buffer[i,j].red;
        buffer[i,j].red := buffer[i,j].blue;
        buffer[i,j].blue := b;
      end;
  X.Free
end;

procedure TForm1.ZobrazitScenu;
begin
  wglMakeCurrent(Canvas.Handle,RC);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  InitCollision;
  ProcessKeyb;
  Collision;
  VlastnostiObjektu;
  DrawElements;
  ClipPlane;
  glFlush;
  SwapBuffers(Canvas.Handle);
  wglMakeCurrent(0,0)
end;

procedure TForm1.VymazatPlochu(var Message: TWMEraseBkgnd);
begin
  Message.Result := 1
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  UhelX := 0;
  UhelY := 0;
  UhelZ := 0;
  X := 0; Y := 0; Z := 10;
  InicializaceOpenGL;
  Handles := BeginThread(nil, 0, Tread, nil, 0, ThreadID);
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  wglDeleteContext(RC);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
    ZobrazitScenu;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  wglMakeCurrent(Canvas.Handle,RC);
  NastaveniProstoru;
  ZobrazitScenu;
  wglMakeCurrent(0,0);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_UP: begin  //ipka nahoru
       KeybUp := True;
    end;
  end;
  case Key of
    VK_DOWN: begin //ipka dolu
      KeybDown := True;
    end;
  end;
  case Key of
    VK_RIGHT: begin //doprava
      KeybRight := True;
    end;
  end;
  case Key of
    VK_LEFT: begin //doleva
      KeybLeft := True;
    end;
  end;
  case Key of
    VK_Home: begin //doprava
      KeybHome := True;
    end;
  end;
  case Key of
    VK_END: begin //doleva
      KeybEnd := True;
    end;
  end;
  case Key of
    27: begin //Q - Quit
      Application.Terminate;
      RestoreMode;
    end;
  end;
  case Key of
    VK_Return: begin //Enter
      SetFullScreen(640,480,16);
    end;
  end;
  case Key of
    VK_Prior: begin //pohyb nahoru
      KeybMoveUp := True;
    end;
  end;
  case Key of
    VK_Next: begin //pohyb dolu
      KeybMoveDown := True;
    end;
  end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_UP: begin  //ipka nahoru
       KeybUp := False;
    end;
  end;
  case Key of
    VK_DOWN: begin //ipka dolu
      KeybDown := False;
    end;
  end;
  case Key of
    VK_RIGHT: begin //doprava
      KeybRight := False;
    end;
  end;
  case Key of
    VK_LEFT: begin //doleva
      KeybLeft := False;
    end;
  end;
  case Key of
    VK_Home: begin //pohled nahoru
      KeybHome := False;
    end;
  end;
  case Key of
    VK_END: begin //pohled dolu
      KeybEnd := False;
    end;
  end;
  case Key of
    VK_Prior: begin //pohyb nahoru
      KeybMoveUp := False;
    end;
  end;
  case Key of
    VK_Next: begin //pohyb dolu
      KeybMoveDown := False;
    end;
  end;
end;

procedure TForm1.ProcessKeyb;
begin
  if KeybUp then begin
    Z := Z + ((-sin((UhelY - 90) * (Pi/180))) * 0.08);
    X := X - ((sin((UhelY) * (Pi/180))) * 0.08);
  end;
  if KeybDown then begin
      Z := Z - ((-sin((UhelY - 90) * (Pi/180))) * 0.08);
      X := X + ((sin((UhelY) * (Pi/180))) * 0.08);
  end;
  if KeybRight then begin
      UhelY := UhelY + 1;
  end;
  if KeybLeft then begin
      UhelY := UhelY - 1;
  end;
  if KeybHome then begin
      UhelX := UhelX - 1;
  end;
  if KeybEnd then begin
      UhelX := UhelX + 1;
  end;
  if KeybMoveUp then begin
    Y := Y - 0.08;
  end;
  if KeybMoveDown then begin
    Y := Y + 0.08;
  end;
end;

procedure TForm1.SetFullScreen(SizeX,SizeY,Bits:longint);
var dmScreenSettings: DEVMODE;
begin
  ZeroMemory( @dmScreenSettings, sizeof( DEVMODE ) );
  dmScreenSettings.dmSize := sizeof( DEVMODE );
  dmScreenSettings.dmPelsWidth  := SizeX; // Width
  dmScreenSettings.dmPelsHeight := SizeY; // Height
  dmScreenSettings.dmFields     := DM_PELSWIDTH or DM_PELSHEIGHT; // Color Depth
  dmScreenSettings.dmBitsPerPel := Bits;
  ChangeDisplaySettings(dmScreenSettings, CDS_FULLSCREEN); // Switch To Fullscreen Mode

  Form1.WindowState := wsMaximized;
end; { SetFullScreen }

procedure TForm1.RestoreMode;
begin
  ChangeDisplaySettings(DEVMODE(nil^), 0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RestoreMode;
end;

procedure TForm1.InitCollision;
var
  Ax, Ay, Az,
  Bx, By, Bz,
  Cx, Cy, Cz,
  Dx, Dy, Dz: double;                 //Body objektu
  Px, Py, Pz: double;                 //Pozice kamery
  Xdiff, Ydiff, Zdiff, Cdiff, Fdiff : boolean;       //Kolizni hodnoty
  i: integer;                         //Pocet objektu
begin
  //pozice kamery
  Px := X;
  Py := -Y;                           //znamenko minus je tam proto, aby odpovidala Y souradnice kamery Y souradnici objektu
  Pz := -Z;                           //znamenko minus je tam proto, aby odpovidala Z souradnice kamery Y souradnici objektu

  for i := 1 to 6 do begin
    //stena 1
    if i = 1 then begin
      //pozice bodu A
      Ax := VertexPointer[0].X;
      Ay := VertexPointer[0].Y;
      Az := VertexPointer[0].Z;
      //pozice bodu B
      Bx := VertexPointer[1].X;
      By := VertexPointer[1].Y;
      Bz := VertexPointer[1].Z;
      //pozice bodu C
      Cx := VertexPointer[2].X;
      Cy := VertexPointer[2].Y;
      Cz := VertexPointer[2].Z;
      //pozice bodu D
      Dx := VertexPointer[5].X;
      Dy := VertexPointer[5].Y;
      Dz := VertexPointer[5].Z;
    end;
    //stena 2
    if i = 2 then begin
      //pozice bodu A
      Ax := VertexPointer2[0].X;
      Ay := VertexPointer2[0].Y;
      Az := VertexPointer2[0].Z;
      //pozice bodu B
      Bx := VertexPointer2[1].X;
      By := VertexPointer2[1].Y;
      Bz := VertexPointer2[1].Z;
      //pozice bodu C
      Cx := VertexPointer2[2].X;
      Cy := VertexPointer2[2].Y;
      Cz := VertexPointer2[2].Z;
      //pozice bodu D
      Dx := VertexPointer2[5].X;
      Dy := VertexPointer2[5].Y;
      Dz := VertexPointer2[5].Z;
    end;
    //stena 3
    if i = 3 then begin
      //pozice bodu A
      Ax := VertexPointer3[0].X;
      Ay := VertexPointer3[0].Y;
      Az := VertexPointer3[0].Z;
      //pozice bodu B
      Bx := VertexPointer3[1].X;
      By := VertexPointer3[1].Y;
      Bz := VertexPointer3[1].Z;
      //pozice bodu C
      Cx := VertexPointer3[2].X;
      Cy := VertexPointer3[2].Y;
      Cz := VertexPointer3[2].Z;
      //pozice bodu D
      Dx := VertexPointer3[5].X;
      Dy := VertexPointer3[5].Y;
      Dz := VertexPointer3[5].Z;
    end;
    //stena 4
    if i = 4 then begin
      //pozice bodu A
      Ax := VertexPointer4[0].X;
      Ay := VertexPointer4[0].Y;
      Az := VertexPointer4[0].Z;
      //pozice bodu B
      Bx := VertexPointer4[1].X;
      By := VertexPointer4[1].Y;
      Bz := VertexPointer4[1].Z;
      //pozice bodu C
      Cx := VertexPointer4[2].X;
      Cy := VertexPointer4[2].Y;
      Cz := VertexPointer4[2].Z;
      //pozice bodu D
      Dx := VertexPointer4[5].X;
      Dy := VertexPointer4[5].Y;
      Dz := VertexPointer4[5].Z;
    end;
    //strop
    if i = 5 then begin
      //pozice bodu A
      Ax := VertexPointer5[0].X;
      Ay := VertexPointer5[0].Y;
      Az := VertexPointer5[0].Z;
      //pozice bodu B
      Bx := VertexPointer5[1].X;
      By := VertexPointer5[1].Y;
      Bz := VertexPointer5[1].Z;
      //pozice bodu C
      Cx := VertexPointer5[2].X;
      Cy := VertexPointer5[2].Y;
      Cz := VertexPointer5[2].Z;
      //pozice bodu D
      Dx := VertexPointer5[5].X;
      Dy := VertexPointer5[5].Y;
      Dz := VertexPointer5[5].Z;
    end;

    //podlaha
    if i = 6 then begin
      //pozice bodu A
      Ax := VertexPointer6[0].X;
      Ay := VertexPointer6[0].Y;
      Az := VertexPointer6[0].Z;
      //pozice bodu B
      Bx := VertexPointer6[1].X;
      By := VertexPointer6[1].Y;
      Bz := VertexPointer6[1].Z;
      //pozice bodu C
      Cx := VertexPointer6[2].X;
      Cy := VertexPointer6[2].Y;
      Cz := VertexPointer6[2].Z;
      //pozice bodu D
      Dx := VertexPointer6[5].X;
      Dy := VertexPointer6[5].Y;
      Dz := VertexPointer6[5].Z;
    end;

    //rozdily vzdalenosti bodu
    if Ax <= Bx then
      Xdiff := True
    else
      Xdiff := False;

    if Cy <= Ay then
      Ydiff := True
    else
      Ydiff := False;

    if Dz <= Cz then
      Zdiff := True
    else
      Zdiff := False;


    //vypocet
    //X hodnota
    if Xdiff then begin
      if ((Bx - Ax) <= 0) then begin             //zrusi nulovou hodnotu
        Ax := Ax - 0.5;
        Bx := Bx + 0.5;
      end;
      if ((Px >= Ax)and(Px <= Bx)) or ((Px >= Cx)and(Px <= Dx)) then
        Xtrue[i] := True
      else
        Xtrue[i] := False;
    end;
    if not Xdiff then begin
      if ((Px >= Bx)and(Px <= Ax)) or ((Px >= Dx)and(Px <= Cx)) then
        Xtrue[i] := True
      else
        Xtrue[i] := False;
    end;
    //Y hodnota
    if Ydiff then begin
      if ((Ay - Cy) <= 0) then begin             //zrusi nulovou hodnotu
          Ay := Ay + 0.5;
          Cy := Cy - 0.5;
      end;
      if ((Py <= Ay)and(Py >= Cy)) or ((Py <= By)and(Py >= Dy)) then
        Ytrue[i] := True
      else
        Ytrue[i] := False;
    end;
    if not Ydiff then begin
      if ((Py <= Cy)and(Py >= Ay)) or ((Py <= Dy)and(Py >= By)) then
        Ytrue[i] := True
      else
        Ytrue[i] := False;
    end;
    //Z hodnota
    if Zdiff then begin
      if ((Az - Bz) <= 0) then begin       //zrusi nulovou hodnotu
        Bz := Bz - 0.5;
        Az := Az + 0.5
      end;
      if (((Pz <= Az)and(Pz >= Bz)) or ((Pz <= Cz)and(Pz >= Dz)))               //steny
      or (((Pz >= Az)and(Pz <= Cz)) or ((Pz >= Bz)and(Pz <= Dz)))  then         //podlaha a strop
        Ztrue[i] := True
      else
        Ztrue[i] := False;
    end;
    if not Zdiff  then begin
      if ((Pz <= Bz)and(Pz >= Az)) or ((Pz <= Dz)and(Pz >= Cz))  then
        Ztrue[i] := True
      else
        Ztrue[i] := False;
    end;

    //posledni pozice kamery pred kolizi
    if (Xtrue[i] = False) or (Ytrue[i] = False) or (Ztrue[i] = False) then begin
      PxLast[i] := X;
      PyLast[i] := Y;
      PzLast[i] := Z;
    end;
  end;

end;

procedure TForm1.Collision;
var
  i: integer;              //pocet objektu
begin
  for i := 1 to 6 do begin
    if Xtrue[i] and Ytrue[i] and Ztrue[i] then begin
      X := PxLast[i];
      Y := PyLast[i];
      Z := PzLast[i];
    end;
  end;
end;

end.
